Attribute VB_Name = "Api"
Option Explicit

Public Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Public Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Public Declare Function GetKeyboardLayoutName Lib "user32" Alias "GetKeyboardLayoutNameA" (ByVal pwszKLID As String) As Long
Public Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long

Public Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function SetCursorPos Lib "user32" (ByVal x As Long, ByVal y As Long) As Long

Public Declare Function ReleaseCapture Lib "user32" () As Long
Public Declare Function OemToChar Lib "user32" Alias "OemToCharA" (ByVal lpszSrc As String, ByVal lpszDst As String) As Long
Public Declare Function CharToOem Lib "user32" Alias "CharToOemA" (ByVal lpszSrc As String, ByVal lpszDst As String) As Long
Public Declare Function ActivateKeyboardLayout Lib "user32" (ByVal HKL As Long, ByVal flags As Long) As Long
Public Declare Function LoadKeyboardLayout Lib "user32" Alias "LoadKeyboardLayoutA" (ByVal pwszKLID As String, ByVal flags As Long) As Long
Public Declare Sub mouse_event Lib "user32" (ByVal dwFlags As Long, ByVal dx As Long, ByVal dy As Long, ByVal cbuttons As Long, ByVal dwExtraInfo As Long)
Public Declare Function ClientToScreen Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
Public Declare Function ScreenToClient Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
Public Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal lpString As String, ByVal nCount As Long) As Long


Public Const SM_CXFRAME = 32
Public Const SM_CYFRAME = 33
Public Const SM_CYCAPTION = 4
Public Const SM_CYMENU = 15
Public Const HWND_TOPMOST = -1
Public Const HWND_NOTOPMOST = -2
Public Const SWP_NOMOVE = &H2
Public Const SWP_NOSIZE = &H1
Public Const SWP_NOACTIVATE = &H10
Public Const SWP_SHOWWINDOW = &H40
Public Const flags = SWP_NOMOVE Or SWP_NOSIZE
Public Const LP_HT_CAPTION = 2
Public Const WM_NCLBUTTONDOWN = &HA1
Public Const WM_NCLBUTTONUP = &HA2

Public Const EM_EMPTYUNDOBUFFER = &HCD
Public Const EM_CANUNDO = &HC6
Public Const EM_GETMODIFY = &HB8
Public Const EM_SETMODIFY = &HB9
Public Const EM_UNDO = &HC7
Public Const GWL_STYLE = (-16)
Public Const ES_NUMBER = &H2000
Public Const ES_UPPERCASE = &H8&
Public Const MOUSEEVENTF_LEFTDOWN = &H2
Public Const MOUSEEVENTF_LEFTUP = &H4
Public Const MOUSEEVENTF_MIDDLEDOWN = &H20
Public Const MOUSEEVENTF_MIDDLEUP = &H40
Public Const MOUSEEVENTF_RIGHTDOWN = &H8
Public Const MOUSEEVENTF_ABSOLUTE = &H8000
Public Const MOUSEEVENTF_MOVE = &H1
Public Const MOUSEEVENTF_RIGHTUP = &H10
Public Const MOUSE_MICKEYS = 65535
Public Const SM_CXSCREEN = 0
Public Const SM_CYSCREEN = 1
Public Const TWIPS_PER_INCH = 1440
Public Const POINTS_PER_INCH = 72
Public Const KLF_ACTIVATE = 1

Public Enum ButtonClick
    btcLeft
    btcRight
    btcMiddle
End Enum
Public Type POINTAPI
    x As Long
    y As Long
End Type
Public Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type
Public Enum enReportStyle
    rsPixels
    rsTwips
    rsInches
    rsPoints
End Enum

'   
Public Sub TextExtent(txt As String, W As Single, H As Single)
    frmGraf.labMeasure.Caption = txt
    W = frmGraf.labMeasure.Width
    H = frmGraf.labMeasure.Height
End Sub

' Returns the screen size in pixels or, optionally, in others scalemode styles
Public Sub GetScreenRes(ByRef x As Long, ByRef y As Long, Optional ByVal ReportStyle As enReportStyle)
    x = GetSystemMetrics(SM_CXSCREEN)
    y = GetSystemMetrics(SM_CYSCREEN)
    If Not IsMissing(ReportStyle) Then
        If ReportStyle <> rsPixels Then
            x = x * Screen.TwipsPerPixelX
            y = y * Screen.TwipsPerPixelY
            If ReportStyle = rsInches Or ReportStyle = rsPoints Then
                x = x \ TWIPS_PER_INCH
                y = y \ TWIPS_PER_INCH
                If ReportStyle = rsPoints Then
                    x = x * POINTS_PER_INCH
                    y = y * POINTS_PER_INCH
                End If
            End If
        End If
    End If
End Sub

' Convert's the mouses coordinate system to a pixel position.
Public Function MickeyXToPixel(ByVal mouseX As Long) As Long
    Dim x As Long, y As Long, tX As Single, tmouseX As Single, tMickeys As Single
    GetScreenRes x, y
    tX = x
    tMickeys = MOUSE_MICKEYS
    tmouseX = mouseX
    MickeyXToPixel = CLng(tmouseX / (tMickeys / tX))
End Function

' Converts mouse Y coordinates to pixels
Public Function MickeyYToPixel(ByVal mouseY As Long) As Long
    Dim x As Long, y As Long, tY As Single, tmouseY As Single, tMickeys As Single
    GetScreenRes x, y
    tY = y
    tMickeys = MOUSE_MICKEYS
    tmouseY = mouseY
    MickeyYToPixel = CLng(tmouseY / (tMickeys / tY))
End Function

'   X   
Public Function PixelXToMickey(ByVal pixX As Long) As Long
    Dim x As Long
    Dim y As Long
    Dim tX As Single
    Dim tpixX As Single
    Dim tMickeys As Single
    GetScreenRes x, y
    tMickeys = MOUSE_MICKEYS
    tX = x
    tpixX = pixX
    PixelXToMickey = CLng((tMickeys / tX) * tpixX)
End Function

'   Y   
Public Function PixelYToMickey(ByVal pixY As Long) As Long
    Dim x As Long
    Dim y As Long
    Dim tY As Single
    Dim tpixY As Single
    Dim tMickeys As Single
    GetScreenRes x, y
    tMickeys = MOUSE_MICKEYS
    tY = y
    tpixY = pixY
    PixelYToMickey = CLng((tMickeys / tY) * tpixY)
End Function

'  
Public Sub RascKord(Contr As Control, xLeft As Single, yTop As Single, dx As Single, dy As Single)
    Contr.Left = -xLeft + dx
    Contr.Top = -yTop + dy
End Sub

Public Function CenterMouseOn(ByVal hwnd As Long) As Boolean
    Dim x As Long
    Dim y As Long
    Dim maxX As Long
    Dim maxY As Long
    Dim crect As RECT
    Dim rc As Long
    GetScreenRes maxX, maxY
    rc = GetWindowRect(hwnd, crect)
    If rc Then
        '    
        x = crect.Left + 2
        y = crect.Top + 2
        '   
'        x = crect.Left + ((crect.Right - crect.Left) / 2)
'        y = crect.Top + ((crect.Bottom - crect.Top) / 2)
        If (x >= 0 And x <= maxX) And (y >= 0 And y <= maxY) Then
            MouseMove x, y
            CenterMouseOn = True
        Else
            CenterMouseOn = False
        End If
    Else
        CenterMouseOn = False
    End If
End Function

Public Function MouseFullClick(ByVal MBClick As ButtonClick) As Boolean
    Dim cbuttons As Long
    Dim dwExtraInfo As Long
    Dim mevent As Long
    Select Case MBClick
        Case btcLeft
            mevent = MOUSEEVENTF_LEFTDOWN Or MOUSEEVENTF_LEFTUP
        Case btcRight
            mevent = MOUSEEVENTF_RIGHTDOWN Or MOUSEEVENTF_RIGHTUP
        Case btcMiddle
            mevent = MOUSEEVENTF_MIDDLEDOWN Or MOUSEEVENTF_MIDDLEUP
        Case Else
            MouseFullClick = False
        Exit Function
    End Select
    mouse_event mevent, 0&, 0&, cbuttons, dwExtraInfo
    MouseFullClick = True
End Function

Public Sub MouseMove(ByRef xPixel As Long, ByRef yPixel As Long)
    Dim cbuttons As Long
    Dim dwExtraInfo As Long
    mouse_event MOUSEEVENTF_ABSOLUTE Or MOUSEEVENTF_MOVE, PixelXToMickey(xPixel), PixelYToMickey(yPixel), cbuttons, dwExtraInfo
End Sub

